# Class GroundExtension

Extends the capabilities of an Esri Ground object.

#### Hierarchy (view full)

- EntityBase<GroundExtensionProperties>
  - GroundExtension

#####
Index

### Constructors

constructor

### Properties

_id
_itemType
_watchHandles
taskSettings
factory

### Accessors

failureMode
ground
id
isDestroyed
isInitialized
itemType
layerExtensions
mapExtension

### Methods

_createTaskSettings
_getSerializableProperties
_initializableChildCollections
_initializeChildren
_onDestroy
_onInitialize
_onLayerAddedPostInitialize
_postInitialize
_toPropertyDef
assignProperties
assignPropertiesAsync
destroy
emit
finishAssignProperties
getDefault
getDefaults
getSerializableProperties
initialize
on
toItemUri
toJSON
create
isDefaultGround

##
Constructors

### constructor

- new GroundExtension(properties?): GroundExtension

- Creates a new instance of mapping/GroundExtension!GroundExtension.

  #### Parameters

  - `Optional` properties: GroundExtensionProperties

    An object containing initial property values to set.

  #### Returns GroundExtension

  Overrides EntityBase.constructor

##
Properties

### `Protected`_id

_id: string

The unique ID for this entity. Once set, this should never change.

Inherited from EntityBase._id

### `Protected` `Readonly`_itemType

_itemType: string = ItemType.GROUND_EXTENSION

The item type for this entity when it participates in an App.

Overrides EntityBase._itemType

### `Protected` `Readonly`_watchHandles

_watchHandles: IHandle[] = []

A set of watch handles that get cleaned up when the class instance is destroyed.

### `Readonly` taskSettings

taskSettings: TaskSettings

#### Inherit Doc

### `Static` factory

factory: GroundExtensionFactory = defaultGroundExtensionFactory

The factory that will be used whenever a GroundExtension needs to be created. Applications can supply their own factory to customize GroundExtension creation.

##
Accessors

### failureMode

- get failureMode(): FailureMode

- Determines how a parent object should handle initialization failure in this object. The default is "warn".

  - `"error"`: support/InitializeError!InitializeError is thrown.
  - `"warn"`: Message is logged and support/InitializableBase!InitializeWarningEvent is raised.
  - `"ignore"`: support/InitializableBase!InitializeWarningEvent is raised.

  #### Returns FailureMode

  Inherited from EntityBase.failureMode

- set failureMode(value): void

- #### Parameters

  - value: FailureMode

  #### Returns void

  Inherited from EntityBase.failureMode

### ground

- get ground(): Ground

- The Esri Ground object being extended.

  #### Returns Ground

### id

- get id(): string

- The unique ID for this entity.

  #### Returns string

  Inherited from EntityBase.id

### isDestroyed

- get isDestroyed(): boolean

- See support/InitializableBase!Initializable.isDestroyed.

  #### Returns boolean

  Inherited from EntityBase.isDestroyed

### isInitialized

- get isInitialized(): boolean

- See support/InitializableBase!Initializable.isInitialized.

  #### Returns boolean

  Inherited from EntityBase.isInitialized

### itemType

- get itemType(): string

- The item type for this entity when it participates in an App.

  #### Returns string

  Inherited from EntityBase.itemType

### layerExtensions

- get layerExtensions(): LayerExtensionCollection<LayerExtensionProperties>

- The layer extensions associated with each layer of the Ground object.

  #### Returns LayerExtensionCollection<LayerExtensionProperties>

### mapExtension

- get mapExtension(): MapExtension

- The parent map extension.

  #### Returns MapExtension

##
Methods

### `Protected`_createTaskSettings

- _createTaskSettings(): TaskSettings

- Called to create the data/TaskSettings!TaskSettings.

  #### Returns TaskSettings

### `Protected`_getSerializableProperties

- _getSerializableProperties(): PropertyDefs<GroundExtensionProperties>

- The property keys and their metadata that are used to implement serializing and deserializing the class instance.

  #### Returns PropertyDefs<GroundExtensionProperties>

  Overrides EntityBase._getSerializableProperties

### `Protected`_initializableChildCollections

- _initializableChildCollections(): IterableIterator<Collection<InitializableBase<InitializableBaseProperties>>, any, any>

- Collections of child items to initialize. Items that fail to initialize are removed from the collection.

  #### Returns IterableIterator<Collection<InitializableBase<InitializableBaseProperties>>, any, any>

  Overrides EntityBase._initializableChildCollections

### `Protected`_initializeChildren

- _initializeChildren(): Promise<void>

- Initializes child entities.

  #### Returns Promise<void>

  Inherited from EntityBase._initializeChildren

### `Protected`_onDestroy

- _onDestroy(): Promise<void>

- Called to perform cleanup. Subclasses should override this method rather than destroy() to perform custom cleanup.

  #### Returns Promise<void>

  Overrides EntityBase._onDestroy

### `Protected`_onInitialize

- _onInitialize(): Promise<void>

- Called to perform initialization of the support/InitializableBase!InitializableBase. Subclasses should override this method rather than initialize() to perform custom initialization.

  #### Returns Promise<void>

  Overrides EntityBase._onInitialize

### `Protected`_onLayerAddedPostInitialize

- _onLayerAddedPostInitialize(layerX): Promise<void>

- A callback executed when a layer is added as a child of the GroundExtension, after the GroundExtension has been initialized.

  #### Parameters

  - layerX: LayerExtension<LayerExtensionProperties>

    The layer that was added.

  #### Returns Promise<void>

### `Protected`_postInitialize

- _postInitialize(): Promise<void>

- Called after normal initialization. Note: Child items are initialized before this is called.

  #### Returns Promise<void>

  Overrides EntityBase._postInitialize

### `Protected`_toPropertyDef

- _toPropertyDef<T>(def): PropertyDef<T>

- Converts the value to a PropertyDef object.

  #### Type Parameters

  - T

  #### Parameters

  - def: PropertyDefSerializeMode | PropertyDefSerializeMode[] | PropertyDef<T>

    The value to convert.

  #### Returns PropertyDef<T>

  Inherited from EntityBase._toPropertyDef

### assignProperties

- assignProperties(properties): void

- #### Parameters

  - properties: Partial<GroundExtensionProperties>

  #### Returns void

  #### Inherit Doc

  Inherited from EntityBase.assignProperties

### assignPropertiesAsync

- assignPropertiesAsync(properties): Promise<void>

- #### Parameters

  - properties: Partial<GroundExtensionProperties>

  #### Returns Promise<void>

  #### Inherit Doc

  Inherited from EntityBase.assignPropertiesAsync

### destroy

- destroy(): Promise<void>

- A clean-up function that should get called whenever the item is disposed of.

  #### Returns Promise<void>

  Inherited from EntityBase.destroy

### emit

- emit(name, event): boolean

- Emits an event on the instance.

  #### Parameters

  - name: string
  - event: unknown

    The event payload.

    Read more...

  #### Returns boolean

  Inherited from EntityBase.emit

### finishAssignProperties

- finishAssignProperties(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from EntityBase.finishAssignProperties

### getDefault

- getDefault<K>(key): GroundExtensionProperties[K]

- #### Type Parameters

  - K extends keyof GroundExtensionProperties

  #### Parameters

  - key: K

  #### Returns GroundExtensionProperties[K]

  #### Inherit Doc

  Inherited from EntityBase.getDefault

### getDefaults

- getDefaults(): GroundExtensionProperties

- #### Returns GroundExtensionProperties

  #### Inherit Doc

  Inherited from EntityBase.getDefaults

### getSerializableProperties

- getSerializableProperties(serializeMode?): PropertyDefs<GroundExtensionProperties>

- Returns the serializable properties.

  #### Parameters

  - `Optional` serializeMode: SerializeMode

    Optional. If specified, only properties that support the given serialization mode will be returned.

  #### Returns PropertyDefs<GroundExtensionProperties>

  Inherited from EntityBase.getSerializableProperties

### initialize

- initialize(): Promise<void>

- Initializes the item.

  #### Returns Promise<void>

  Inherited from EntityBase.initialize

### on

- on(name, callback): IHandle

- Registers an event handler on the instance.

  #### Parameters

  - name: string | string[]
  - callback: EventCallback<any>

  #### Returns IHandle

  Inherited from EntityBase.on

### toItemUri

- toItemUri(): string

- Creates an item:// URI reference to this entity.

  #### Returns string

  Inherited from EntityBase.toItemUri

### toJSON

- toJSON(serializeMode?): GroundExtensionProperties

- #### Parameters

  - serializeMode: SerializeMode = "all"

  #### Returns GroundExtensionProperties

  #### Inherit Doc

  Inherited from EntityBase.toJSON

### `Static` create

- create(properties?): GroundExtension

- Creates the mapping/GroundExtension!GroundExtension based on the supplied properties. Applications can customize the default creation behavior by supplying a custom factory object (see mapping/GroundExtension!GroundExtension.factory).

  #### Parameters

  - `Optional` properties: GroundExtensionProperties

    The GroundExtension item properties.

  #### Returns GroundExtension

### `Static` isDefaultGround

- isDefaultGround(ground): boolean

- Checks if the Ground object is the one created by default when the EsriAPI parses a ground.

  #### Parameters

  - ground: Ground

    The Ground object to check.

  #### Returns boolean